<?php
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', './../../');

if (!defined('FORUM_ROOT'))	die();

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'extensions/photos_in_profile/resizeimage.php';

if (!isset($lang_pf_photos)) {
	if (file_exists(FORUM_ROOT.'extensions/photos_in_profile/lang/'.$forum_user['language'].'/photos_in_profile.php'))
	    require FORUM_ROOT.'extensions/photos_in_profile/lang/'.$forum_user['language'].'/photos_in_profile.php';
    else
	    require FORUM_ROOT.'extensions/photos_in_profile/lang/English/photos_in_profile.php';
}

if (!defined('PHOTOS_PROFILE_FUNCTIONS_LOADED'))
	require FORUM_ROOT.'extensions/photos_in_profile/functions.php';

if (isset($_GET['action']))
	define('FORUM_QUIET_VISIT', 1);

$action = isset($_GET['action']) ? $_GET['action'] : null;

if ($action == 'upload_image')
{
	if ($forum_user['g_photos_pf_enable'] == '1' && $forum_user['photos_pf_enable'] == '1')
	{
	    $num_images = pp_get_user_photos_count();

		if ($num_images >= $forum_user['g_photos_pf_max_images'] && $forum_user['g_id'] != FORUM_ADMIN) {
            echo json_encode(array('answer'=>'error', 'error'=>sprintf($lang_pf_photos['Error message body'], sprintf($lang_pf_photos['Error max images'], $forum_user['g_photos_pf_max_images']))));
				
			die;
		}
		
		if(isset($_FILES['file']) && $_FILES['file']['error'] == 0)
		{
		    $tmp_name = $_FILES['file']['tmp_name'];
			$file_name = strtolower(sef_friendly($_FILES['file']['name']));
			$title = pathinfo($_FILES['file']['name'], PATHINFO_FILENAME);
		    $extension = strtolower(pathinfo($_FILES['file']['name'], PATHINFO_EXTENSION));
			$image_types = str_replace(' ', '', $forum_config['o_photos_in_profile_img_types']);
	        $image_types = explode(',', $image_types);
	        $resizes_typs = array('jpg', 'jpeg', 'png', 'gif');
		    $file_size = isset($_FILES['file']['size']) ? $_FILES['file']['size'] : 'undefined';
		    $base_name = md5($file_name.time()).'.'.$extension;

		    if (in_array($extension, $image_types))
		    {
			    $image_link = 'uploads/photos_in_profile/'.$forum_user['id'].'/'.$base_name;
		        $path_to_image = FORUM_ROOT.'uploads/photos_in_profile/'.$forum_user['id'].'/'.$base_name;
		        $dir = FORUM_ROOT.'uploads/photos_in_profile/'.$forum_user['id'].'/';

			    if (!file_exists($dir)) {
                    @mkdir($dir);
                    @chmod($dir, 0777);
                }

			    if (move_uploaded_file($tmp_name, $path_to_image) )
			    {
				    $file_type = 'image';
				    rename($path_to_image, $dir.$base_name);
					
				    if (file_exists($dir.$base_name) )
				    {
					    $new_image = $dir.$base_name;
						$max_width = $forum_config['o_photos_in_profile_img_width'];
						$max_height = $forum_config['o_photos_in_profile_img_height'];

					    list($width, $height) = getimagesize($new_image);
					    if ($width > $max_width OR $height > $max_width)
					    {
						    if ($forum_config['o_photos_in_profile_img_resize'] == '1' && in_array($extension, $resizes_typs)) 
							{
							    try {
							        $resize = new \Eventviva\ImageResize($new_image);
							        $resize->resizeToBestFit($max_width, $max_height); //resize, resizeToHeight, resizeToWidth, resizeToBestFit;
							        $resize->save($new_image, null, 80); //80 = image quality;
							        $image_size = filesize($new_image);
						        } catch(Exception $e) {
						            echo json_encode(array('answer'=>'error', 'error'=>sprintf($lang_pf_photos['Error message body'], $lang_pf_photos['Error upload image'])));
				
	                                die;
						        }
							} else {
								echo json_encode(array('answer'=>'error', 'error'=>sprintf($lang_pf_photos['Error message body'], $lang_pf_photos['Error image size'])));
				
			                    die;
							}
					    } else {
						    $image_size = $file_size;
					    }

					    $query = array(
						    'INSERT'	=> 'user_id, title, base_name, url, ext, size, uploaded',
						    'INTO'		=> 'photos_in_profile',
						    'VALUES'	=> '\''.$forum_db->escape($forum_user['id']).'\', \''.$forum_db->escape($title).'\', \''.$forum_db->escape($base_name).'\', \''.$forum_db->escape($image_link).'\', \''.$forum_db->escape($extension).'\', \''.$forum_db->escape($image_size).'\', '.time()
					    );
					    $forum_db->query_build($query) or error(__FILE__, __LINE__);

	                    $forum_flash->add_info($lang_pf_photos['Image added']);
						
						echo json_encode(array('answer'=>'success'));
				
                        die;
				    }
			    }
		    } else {
	            $image_types = implode(', ', $image_types);
				
			    echo json_encode(array('answer'=>'error', 'error'=>sprintf($lang_pf_photos['Error message body'], sprintf($lang_pf_photos['Error image types'], $image_types))));
				
	            die;
		    }
		}
		
		echo json_encode(array('answer'=>'error', 'error'=>sprintf($lang_pf_photos['Error message body'], $lang_pf_photos['Error upload image'])));
				
	    die;
	}
}

else if ($action == 'set_avatar')
{
	if ($forum_config['o_avatars'] == '1')
	{
		$image_id = isset($_GET['id']) ? intval($_GET['id']) : 0;
		
	    if ($image_id > 0)
	    {
		    $query = array(
		        'SELECT'	=> 'user_id, url, ext',
		        'FROM'		=> 'photos_in_profile',
		        'WHERE'		=> 'id='.$image_id
	        );
	        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	        $image = $forum_db->fetch_assoc($result);

			if (file_exists(FORUM_ROOT.$image['url']) )
		    {
	            $allowed_types = array('jpg', 'png', 'gif');
		        if (in_array($image['ext'], $allowed_types))
		        {
				    delete_avatar($image['user_id']);
				
				    $avatar_img = $forum_config['o_avatars_dir'].'/'.$image['user_id'].'.'.$image['ext'];
				
				    @copy(FORUM_ROOT.$image['url'], FORUM_ROOT.$avatar_img);
				    if (file_exists(FORUM_ROOT.$avatar_img) )
				    {
					    $new_image = FORUM_ROOT.$avatar_img;
				        $max_width = $forum_config['o_avatars_width'];
					    $max_height = $forum_config['o_avatars_height'];

					    list($width, $height, $type) = getimagesize($new_image);
					    if ($width > $max_width OR $height > $max_width)
					    {
						    try {
							    $resize = new \Eventviva\ImageResize($new_image);
							    $resize->resize($max_width, $max_height); //resize, resizeToHeight, resizeToWidth, resizeToBestFit;
								$resize->save($new_image, null, 80, 0644); //80 = image quality;

							    list($res_width, $res_height, $res_type) = getimagesize($new_image);
							    $avatar_type = (intval($res_type) > 0) ? intval($res_type) : 0;
								$avatar_width = (intval($res_width) > 0) ? intval($res_width) : 0;
							    $avatar_height = (intval($res_height) > 0) ? intval($res_height) : 0;
						    } catch(Exception $e) {
						        echo json_encode(array('answer'=>'error', 'msg'=>$lang_pf_photos['Error failed to resize image']));
				
	                            die;
						    }
					    } else {
							$avatar_type = $type;
						    $avatar_width = $width;
					        $avatar_height = $height;
					    }

					    $query = array(
						    'UPDATE'	=> 'users',
						    'SET'		=> 'avatar=\''.$avatar_type.'\', avatar_height=\''.$avatar_height.'\', avatar_width=\''.$avatar_width.'\'',
						    'WHERE'		=> 'id='.$image['user_id']
				        );
					    $forum_db->query_build($query) or error(__FILE__, __LINE__);

						echo json_encode(array('answer'=>'success', 'msg'=>$lang_pf_photos['Photo is set to avatar']));
				
                        die;
				    }
		        } else {
			        echo json_encode(array('answer'=>'error', 'msg'=>$lang_pf_photos['Error avatar types']));
				
	                die;
		        }
			}
		}
		
		echo json_encode(array('answer'=>'error', 'msg'=>$lang_pf_photos['Error image not found']));
				
	    die;
	}
}

else if ($action == 'edit_description')
{
    $image_id = isset($_GET['id']) ? intval($_GET['id']) : 0;
	$title = isset($_GET['title']) ? strip_tags($_GET['title']) : null;

	if ($image_id > 0)
	{
	    if (isset($title) && $title != '')
	    {
		    $query = array(
		        'UPDATE'	=> 'photos_in_profile',
		        'SET'       => 'title =\''.$forum_db->escape($title).'\'',
	            'WHERE'	    => 'id = '.$image_id
	        );
	        $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
            echo json_encode(array('answer'=>'success', 'msg'=>$lang_pf_photos['Description edited']));
				
	        die;
	    } else {
		    echo json_encode(array('answer'=>'error', 'msg'=>$lang_pf_photos['Error field description empty']));
				
	        die;
	    }
	} else {
		echo json_encode(array('answer'=>'error', 'msg'=>$lang_pf_photos['Error image not found']));
				
	    die;
	}
}

else if ($action == 'delete_image')
{
    $image_id = isset($_GET['id']) ? intval($_GET['id']) : 0;
		
	if ($image_id > 0)
	{
		$query1 = array(
		    'SELECT'	=> 'url',
		    'FROM'		=> 'photos_in_profile',
		    'WHERE'		=> 'id='.$image_id
	    );
	    $result1 = $forum_db->query_build($query1) or error(__FILE__, __LINE__);
	    $del_image = $forum_db->fetch_assoc($result1);
		
		$query2 = array(
	        'SELECT'	=> 'id, message',
	        'FROM'		=> 'posts',
	        'WHERE'		=> 'message '.($db_type == 'pgsql' ? 'ILIKE' : 'LIKE').' \''.$forum_db->escape('%'.$del_image['url'].'%').'\''
        );
        $result2 = $forum_db->query_build($query2) or error(__FILE__, __LINE__);

	    while ($edited_post = $forum_db->fetch_assoc($result2)) {
	        $query = array(
		        'UPDATE' => 'posts',
				'SET'    => 'message=\''.$forum_db->escape(str_replace('[img]'.$base_url.'/'.$del_image['url'].'[/img]', '', $edited_post['message'])).'\'',
		        'WHERE'	 => 'id=\''.$forum_db->escape($edited_post['id']).'\''
	        );
	        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    }
		
		if (file_exists(FORUM_ROOT.$del_image['url']))
		    unlink(FORUM_ROOT.$del_image['url']);
		
		$query = array(
		    'DELETE'	=> 'photos_in_profile',
		    'WHERE'		=> 'id='.$image_id
	    );
	    $forum_db->query_build($query) or error(__FILE__, __LINE__);

	    $message = $lang_pf_photos['Image deleted'];
	    $forum_flash->add_info($message);
	}
}

else if ($action == 'photos_disable')
{
	$user_id = isset($_GET['id']) ? intval($_GET['id']) : 0;
	
	if ($forum_user['g_id'] == FORUM_ADMIN && $user_id != $forum_user['id']) {
		$query = array(
    	    'SELECT'	=> 'photos_pf_disable_adm',
		    'FROM'		=> 'users',
		    'WHERE'		=> 'id='.$user_id
        );
        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$pf_status = $forum_db->fetch_assoc($result);

		if ($pf_status['photos_pf_disable_adm'] == 1) { $status = 0; $message = $lang_pf_photos['Photos in profile enabled']; } else { $status = 1; $message = $lang_pf_photos['Photos in profile disabled']; }
		
		$query = array(
			'UPDATE'	=> 'users',
			'SET'		=> 'photos_pf_disable_adm='.$status,
			'WHERE'		=> 'id='.$user_id
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);

		$forum_flash->add_info($message);
		redirect(forum_link($forum_url['profile_admin'], $user_id), $message);
    }
}
