<?php

if (!defined('FORUM_ROOT'))
	die();

$sort_by = isset($_GET['sort_by']) ? 'sort_by='.$_GET['sort_by'] : '';

if ($section == 'photos')
{
	require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
    require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';
	
	if (!isset($lang_pf_photos)) {
	    if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php'))
	        require $ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php';
        else
	        require $ext_info['path'].'/lang/English/'.$ext_info['id'].'.php';
    }
	
	if (!defined('PHOTOS_PROFILE_FUNCTIONS_LOADED'))
	    require $ext_info['path'].'/functions.php';

	$check_access = pp_check_access();
	$allow_avatar = pp_allow_avatar();
	$num_images = pp_get_user_photos_count($id);

	if ($num_images > 0)
    {
	    $max_items = 12; //	$forum_user['disp_posts'];
		
		//Page Navigation
	    $forum_page['num_pages'] = ceil($num_images / $max_items);
	    $forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
	    $forum_page['start_from'] = $max_items * ($forum_page['page'] - 1);
	    $forum_page['finish_at'] = min(($forum_page['start_from'] + $max_items), ($num_images));
	    $forum_page['items_info'] = generate_items_info($lang_pf_photos['Photos'], ($forum_page['start_from'] + 1), $num_images);
	    if ($forum_page['num_pages'] > 1)
		    $forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_pf_photos['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], str_replace($base_url,"",forum_link($forum_url['photos_profile'], $id)), ' ').'</p>';
    } else {
		$forum_page['start_from'] = 0;
	}
	
	if (isset($_GET['add_image']))
    {
	    if ($forum_user['id'] != $id || $check_access == false)
			message($lang_common['Bad request']);
		
		unset($forum_page['page_post']['paging']);

		$image_types = str_replace(",", ", ", $forum_config['o_photos_in_profile_img_types']);
	    $forum_page['frm_info']['image_info'] = '<li><span>'.sprintf($lang_pf_photos['Allowed image types'], $image_types).'</span></li>';
	    $forum_page['frm_info']['image_size'] = '<li><span>'.sprintf($lang_pf_photos['Max image size'], $forum_config['o_photos_in_profile_img_width'], $forum_config['o_photos_in_profile_img_height']).'</span></li>';
		
		if ($forum_config['o_photos_in_profile_img_resize'] == '1')
		    $forum_page['frm_info']['image_resize'] = '<li><span>'.$lang_pf_photos['Images will be resized'].'</span></li>';

	    $forum_page['redirect_page'] = forum_link($forum_url['photos_profile'], $id);

	    // Setup breadcrumbs
	    $forum_page['crumbs'] = array(
		    array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		    array(sprintf($lang_profile['Users profile'], $user['username']), forum_link($forum_url['user'], $id)),
		    array($lang_pf_photos['Photos'], forum_link($forum_url['photos_profile'], $id)),
		    $lang_pf_photos['Adding image']
	    );
		
		$forum_page['main_head'] = end($forum_page['crumbs']);

	    define('FORUM_PAGE', 'profile-photos_add_image');
	    require FORUM_ROOT.'header.php';

	    // START SUBST - <!-- forum_main -->
	    ob_start();
?>
	    <div class="main-subhead" redirect_url="<?php echo $forum_page['redirect_page'] ?>">
		    <h2 class="hn"><span><?php echo $forum_page['main_head'] ?></span></h2>
	    </div>
	    <div class="main-content main-frm">
		    <div class="ct-box error-box"></div>
		    <div class="ct-box info-box">
				<ul class="info-list">
					<?php echo implode("\n\t\t\t\t\t", $forum_page['frm_info'])."\n" ?>
				</ul>
			</div>
			<div class="frm-buttons">
				<span id="upload_button" class="submit primary"><?php echo $lang_pf_photos['Upload'] ?><input id="profile_upload_image" name="file" onchange="UploadImageToProfile()" type="file" title=""></span>
				<span class="cancel"><input type="submit" name="cancel" value="<?php echo $lang_common['Cancel'] ?>" onclick="window.location.href = '<?php echo $forum_page['redirect_page'] ?>'; return false;" /></span>
			</div>
	    </div>

<?php

	    $tpl_temp = forum_trim(ob_get_contents());
	    $tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	    ob_end_clean();
	    // END SUBST - <!-- forum_main -->

	    require FORUM_ROOT.'footer.php';
    }

	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array(sprintf($lang_profile['Users profile'], $user['username']), forum_link($forum_url['user'], $id)),
		$lang_pf_photos['Photos']
	);

	define('FORUM_PAGE', 'profile-photos');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

    if ($num_images > 0) { 

        if($sort_by == 'sort_by=uploaded_ASC')
		    $sort_query = 'uploaded ASC';
	    else if($sort_by == 'sort_by=uploaded_DESC')
		    $sort_query = 'uploaded DESC';
	    else if($sort_by == 'sort_by=size_ASC')
		    $sort_query = 'size ASC';
	    else if($sort_by == 'sort_by=size_DESC')
		    $sort_query = 'size DESC';
	    else
		    $sort_query = 'uploaded DESC';

	    $query = array(
		    'SELECT'	=> '*',
		    'FROM'		=> 'photos_in_profile',
		    'WHERE'		=> 'user_id='.$id,
		    'ORDER BY'	=> ''.$sort_query,
		    'LIMIT'		=> $forum_page['start_from'].', '.$max_items
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
?>
	    <div class="main-content main-frm">
		    <div class="main-subhead m-subhead">
			    <h2 class="hn"><span><?php echo sprintf($lang_pf_photos['User`s Photos'], $num_images) ?></span></h2>
<?php				
				if ($num_images > 1) {
?>				
			        <select id="photos_sort_by" onchange="Photos_sort_by(this)" url="<?php echo forum_link($forum_url['photos_profile_sort_by'], $id) ?>">
			            <option value="sort_by=uploaded_DESC"<?php if ($sort_query == 'uploaded DESC') echo ' selected="selected"' ?>><?php echo $lang_pf_photos['Sort by upload date desc'] ?></option>
			            <option value="sort_by=uploaded_ASC"<?php if ($sort_query == 'uploaded ASC') echo ' selected="selected"' ?>><?php echo $lang_pf_photos['Sort by upload date asc'] ?></option>
				        <option value="sort_by=size_DESC"<?php if ($sort_query == 'size DESC') echo ' selected="selected"' ?>><?php echo $lang_pf_photos['Sort by file size desc'] ?></option>
				        <option value="sort_by=size_ASC"<?php if ($sort_query == 'size ASC') echo ' selected="selected"' ?>><?php echo $lang_pf_photos['Sort by file size asc'] ?></option>
		            </select>
<?php				
				}
?>
		    </div>
	
		    <div class="image_list">
<?php
            $i = isset($_GET['p']) ? $max_items * ($forum_page['page']-1)+1 : '1';	
	        while ($image = $forum_db->fetch_assoc($result)) {

				if (utf8_strlen($image['title']) > 34) { $img_name = utf8_substr($image['title'],0,34); } else { $img_name = $image['title']; }
?>
				    <div class="pf_image">
<?php 
                        if ($forum_user['id'] == $id && $check_access == true || $forum_user['g_id'] == FORUM_ADMIN) { 
                            if ($forum_config['o_avatars'] == '1' && $allow_avatar == true && in_array($image['ext'], array('jpg', 'png', 'gif'))) { 
?>
							    <span class="pf_manager pf_del_image_a" onclick="PfConfirmFunction('<?php echo $lang_pf_photos['Delete image'] ?>', DeleteUploadedImage, '<?php echo $image['id'] ?>')" title="<?php echo $lang_pf_photos['Delete a image'] ?>"></span>
								<span class="pf_manager pf_set_avatar" onclick="PfConfirmFunction('<?php echo $lang_pf_photos['Set avatar'] ?>', SetImageToAvatar, '<?php echo $image['id'] ?>')" title="<?php echo $lang_pf_photos['Set to avatar'] ?>"></span>
<?php
                            } else {
?>
						        <span class="pf_manager pf_del_image_b" onclick="PfConfirmFunction('<?php echo $lang_pf_photos['Delete image'] ?>', DeleteUploadedImage, '<?php echo $image['id'] ?>')" title="<?php echo $lang_pf_photos['Delete a image'] ?>"></span>
<?php								
							}
?>						
						    <span class="pf_manager pf_edit_description" onclick=" EditDescriptionImage('<?php echo $image['id'] ?>')" title="<?php echo $lang_pf_photos['Edit a description'] ?>"></span>
<?php						
						} 
?>
						<span class="pf_manager pf_copy_link" onclick="CopyLinkToClipboard('<?php echo forum_link($image['url']) ?>', '<?php echo $lang_pf_photos['Link copied to clipboard'] ?>');" title="<?php echo $lang_pf_photos['Copy link to clipboard'] ?>"></span>
				        <span class="pf_content"><a class="pf_images" rel="group" href="<?php echo forum_link($image['url']) ?>" title="<?php echo $image['title'] ?>"><img src="<?php echo forum_link($image['url']) ?>" /></a></span>
				        <div class="image_name img_title_<?php echo $image['id'] ?>"><p><?php echo $img_name ?></p>
						    <p class="img_data_<?php echo $image['id'] ?>"><span><?php echo date("d.m.Y  H:i", $image['uploaded']); ?></span><span style="float:right;"><?php echo $lang_pf_photos['Size'] ?>: <?php echo round($image['size']/1024, 1).' kB'; ?></span></p>
						</div>
				    </div>
<?php
	        $i++;
	        }
?>
		    </div>
<?php
    } else {
?>
	    <div class="main-content main-frm">
		    <div class="main-subhead m-subhead">
			    <h2 class="hn"><span><?php echo sprintf($lang_pf_photos['User`s Photos'], 0) ?></span></h2>
		    </div>
		    <div class="ct-box info-box"><span><?php echo $lang_pf_photos['No images found'] ?></span></div>
<?php
    }

	if ($forum_user['id'] == $id && $check_access == true) {
?>
	    <div class="frm-buttons" style="margin-top: 0;">
			<span class="submit primary"><input type="submit" value="<?php echo $lang_pf_photos['Add image'] ?>" onclick="window.location.href = '<?php echo forum_link($forum_url['photos_profile_add'], $id) ?>'; return false;" /></span>
		</div>
<?php
	}
?>
	</div>
<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->

	require FORUM_ROOT.'footer.php';
}
